import random
import numpy as np
import inspect
import poetryrelations
import pickle
from inspect import getmembers, isfunction
import sys

functions_list = [o for o in getmembers(poetryrelations) if isfunction(o[1]) if o[0] != "word"]
functions_name_list = [o[0] for o in functions_list if o[0] != "word"]

poetry_folder = "poems-data"

poems = pickle.load(open(poetry_folder + "/poems.pcl", "rb"))
print(len(poems))
num_poems = len(poems)
poem_vals = {}
poem_vecs = {}

#for (poem_ind, poem) in enumerate(poems[int(sys.argv[1]):int(sys.argv[1]) + 200]):
for (poem_ind, poem) in enumerate(poems):
    print("i: " + str(poem_ind) + " of " + str(num_poems - 1))
    print(poem)
    vec = np.zeros((len(poem), len(poem), len(functions_list)))
    for j in range(len(poem)):
        print("j: " + str(j)) 
        for k in range(len(poem)):
            if j != k:
                #print(j, k)
                for (ind, (name, f)) in enumerate(functions_list):
                    try:
                        if f(poem, j, k):
                            if name == "endrhyme":
                                print("in")
                                vec[j, k, ind] = 5
                            else:
                                vec[j, k, ind] = 1
                    except:
                        print("error")
    poem_vals[tuple(poem)] = vec
    if poem_ind % 20 == 19:
        #pickle.dump(poem_vals, open(poetry_folder + "/poem_vecs" + str(sys.argv[1]) + ".pcl", "wb"))
        pickle.dump(poem_vals, open(poetry_folder + "/poem_vecs.pcl", "wb"))

